# coding: utf-8


import json

from nci._nci_orm import vw_status_model_statusCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import umk_versionCursor


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO



def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''

    umk_version_id = json.loads(session)['sessioncontext']['related']['gridContext']['currentRecordId']
    umk_version = umk_versionCursor(context)
    umk_version.get(umk_version_id)

    # Структура данных
    xformsdata = {"schema":
                  {"@xmlns":"",
                    "data":
                        {
                        "umk_version_id": umk_version_id,
                         "oldstatus": umk_version.status_id,
                         "newstatus": umk_version.status_id
                         }

                    }
                  }

    # действия в зависимости от статуса
    vw_status_model_status = vw_status_model_statusCursor(context)
    vw_status_model_status.setRange('model_id', 3)
    vw_status_model_status.setRange('status_id1', umk_version.status_id)
    xformsdata['schema']['data']['actions'] = []
    xformsdata['schema']['data']['actions'].append({'@label': u'Оставить в текущем статусе',
                                                     '@value': int(umk_version.status_id)})
    for vw_status_model_status in vw_status_model_status.iterate():
        xformsdata['schema']['data']['actions'].append({'@label': vw_status_model_status.status_name2,
                                                     '@value': int(vw_status_model_status.status_id2)})

    # Первоначальная xformssettings
    xformssettings = {"properties":{"event":[{"@name":"single_click",
                                             "@linkId": "1",
                                             "action":{"@keep_user_settings": "true",
                                                '#sorted': [
                                                    {"main_context": "current"},
                                                    {"datapanel": {"@type": "current",
                                                                     "@tab": "current",
                                                                     "element": {"@id":'umkVersionGrid',
                                                                                 "add_context": ""
                                                                                 }
                                                                     }}]
                                                       }
                                             },
                                             {"@name":"single_click",
                                             "@linkId": "2",
                                             "action":{"@keep_user_settings": "true",
                                                '#sorted': [
                                                    {"main_context": "current"},
                                                    {"datapanel": {"@type": "current",
                                                                     "@tab": "current"
                                                                                        ,
                                                                     "element": {"@id":'umkVersionGrid',
                                                                                 "add_context": ""
                                                                                 }
                                                                     }}]
                                                       }
                                             }]
                                    }
                      }


    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)), XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''

    data_dict = json.loads(xformsdata)
    umk_version = umk_versionCursor(context)
    umk_version.get(data_dict['schema']['data']['umk_version_id'])
    # статус должен измениться
    if data_dict['schema']['data']['newstatus'] != data_dict['schema']['data']['oldstatus']:
        umk_version.status_id = int(data_dict['schema']['data']['newstatus'])
        umk_version.update()

